package main

import (
	"fmt"

	"cuelang.org/go/cue/cuecontext"
)

func main() {

	baseStr := "output: {\n\tkind: \"Deployment\"\n\tvolumes: [{\n\t\tname: \"myEmpty\"\n\t}]\n}\noutputs: {}\n\ncontext: _\nparameter: _\n\nparameter: {}\ncontext: {\"appAnnotations\":{},\"appLabels\":{},\"appName\":\"website\",\"appRevision\":\"\",\"appRevisionNum\":0,\"cluster\":\"\",\"clusterVersion\":{\"gitVersion\":\"\",\"major\":\"\",\"minor\":0,\"platform\":\"\"},\"components\":[{\"name\":\"hello\",\"type\":\"mincomp\",\"traits\":[{\"type\":\"min-trait\"}]}],\"name\":\"hello\",\"namespace\":\"default\",\"publishVersion\":\"\",\"replicaKey\":\"\",\"revision\":\"\",\"workflowName\":\"\"}"
	baseVal := cuecontext.New().CompileString(baseStr)
	baseOutputValue := baseVal.LookupPath(FieldPath("output"))

	patchStr := "patch: {\n\t// +patchKey=name\n\tvolumes: [{\n\t\tname: parameter.volumeName // works whether or not default value taken\n\t}]\n}\n\nparameter: {\n\t// +usage=name of host mount volume (default datadog)\n\tvolumeName: *\"my-default-vol\" | string\n}\n\ncontext: {\"appAnnotations\":{},\"appLabels\":{},\"appName\":\"website\",\"appRevision\":\"\",\"appRevisionNum\":0,\"cluster\":\"\",\"clusterVersion\":{\"gitVersion\":\"\",\"major\":\"\",\"minor\":0,\"platform\":\"\"},\"componentType\":\"mincomp\",\"components\":[{\"name\":\"hello\",\"type\":\"mincomp\",\"traits\":[{\"type\":\"min-trait\"}]}],\"name\":\"hello\",\"namespace\":\"default\",\"output\":{\"kind\":\"Deployment\",\"volumes\":[{\"name\":\"myEmpty\"}]},\"publishVersion\":\"\",\"replicaKey\":\"\",\"revision\":\"\",\"workflowName\":\"\"}"
	//patchStr := "patch: {\n\t// +patchKey=name\n\tvolumes: [{\n\t\tname: \"\\(parameter.volumeName)\" // works whether or not default value taken\n\t}]\n}\n\nparameter: {\n\t// +usage=name of host mount volume (default datadog)\n\tvolumeName: *\"my-default-vol\" | string\n}\n\ncontext: {\"appAnnotations\":{},\"appLabels\":{},\"appName\":\"website\",\"appRevision\":\"\",\"appRevisionNum\":0,\"cluster\":\"\",\"clusterVersion\":{\"gitVersion\":\"\",\"major\":\"\",\"minor\":0,\"platform\":\"\"},\"componentType\":\"mincomp\",\"components\":[{\"name\":\"hello\",\"type\":\"mincomp\",\"traits\":[{\"type\":\"min-trait\"}]}],\"name\":\"hello\",\"namespace\":\"default\",\"output\":{\"kind\":\"Deployment\",\"volumes\":[{\"name\":\"myEmpty\"}]},\"publishVersion\":\"\",\"replicaKey\":\"\",\"revision\":\"\",\"workflowName\":\"\"}"
	patchVal := cuecontext.New().CompileString(patchStr)
	patchOutputValue := patchVal.LookupPath(FieldPath("patch"))

	ret, err := strategyUnify(baseOutputValue, patchOutputValue, &UnifyParams{}, []interceptor{strategyPatchHandle()}...)
	retString, err := toString(ret)
	if err != nil {
		fmt.Println("Error: ", err)
		return
	}
	fmt.Println(retString)
}
